// IchigoJam用PCG Character Converter
// (1) PhotoshopでRGBカラー32×56ピクセルのドキュメントを作成します
// (2) このスクリプトを実行するとデスクトップに0char-bit.txtファイルが生成され、
// そこにIchigoJamのBASICプログラムが生成されます。
// 2015/12/4 (c)KaZuhiro FuRuhata
// ver 1.0
(function(){
	var MAX_Y=7;
	var data = [];
	var counter = 0;
	for(var j=0; j<MAX_Y; j++){
		for(var i=0; i<4; i++){
			for(var y=0; y<8; y++){
				var bit = 0;
				for(var x=0; x<8; x++){
					bit = bit << 1;
					bit = bit | getPixel(i*8+x, j*8+y);
				}
				data[counter++] = bit;
			}
		}
	}
	activeDocument.selection.deselect();
	var fileObj = new File("~/Desktop/0char-bit.txt");
	var flag = fileObj.open("w");
	if (flag){
		fileObj.writeln("5 CLS");
		counter = 0;
		for(var j=0; j<MAX_Y; j++){
			var adrs = (0x700+(j*32)).toString(16);
			fileObj.write((1+j)*10+" POKE#"+adrs+",");
			for(var i=0; i<32; i++){
				fileObj.write(data[counter++]);
				if (i<31){ fileObj.write(","); }
			}
			fileObj.writeln();
		}
		fileObj.writeln("90 FOR Y=0TO6:FOR X=0TO3:LC X,Y:?CHR$(#E0+X+Y*4);:NEXT:NEXT:?");
		fileObj.close();
	}
	//---------------------------------------------
	// ピクセル値(白黒)を取得する(8bitモード専用)
	// 戻り値は黒なら0、それ以外は1
	//---------------------------------------------
	function getPixel(x,y){
		var R = G= B= 0,data,i;
		var docObj = activeDocument;
		docObj.selection.select([[x,y],[x+1,y],[x+1,y+1],[x,y+1],[x,y]]);
		data = docObj.channels[0].histogram;
		for (i=0; i<256; i++) if (data[i] > 0) { R = i; break; }
		data = docObj.channels[1].histogram;
		for (i=0; i<256; i++) if (data[i] > 0) { G = i; break; }
		data = docObj.channels[2].histogram;
		for (i=0; i<256; i++) if (data[i] > 0) { B = i; break; }
		if ((R==0) && (G==0) && (B==0)) { return 0; }
		return 1;
	}
})();

